'***********************************************
'
' Uninstall Printer
'
' Date: 08/05/2008
' Version: 1.1.2
'
'***********************************************
Option Explicit

Const wbemFlagReturnImmediately = &h10
Const wbemFlagForwardOnly = &h20

Dim ArgObj
Dim BatchFile
Dim sCommand
Dim WshShell
Dim oEnv
Dim oFileSystem
Dim oWMIService
Dim sGetMyVar
Dim sPrinterShutDown
Dim sPrinter
Dim sPrinterDriver_list
Dim sPrinterDriver_array
Dim oItem
Dim colInstalledPrinters
Dim sPrinterInstalled_list
Dim sPrinterInstalled_array
Dim sPrinterDriverInstalled_list
Dim sPrinterDriverInstalled_array
Dim colInstalledPorts
Dim sTCPIPPort
Dim sTCPIPPorts_list
Dim sTCPIPPorts_array
Dim sHID
Dim sHID_list
Dim sHID_array
Dim sComputer

main

'***********************************************
' Main execution starts here
'***********************************************
Sub main

    DeleteAllPrinters
    
    'Popup dialog when done.
    'MsgBox "All Dell AiO Printers and associated drivers have been uninstalled!", 0, "KODAK EASYSHARE All-in-One Printer"

End Sub

'***********************************************
' Function: DeleteAllPrinters
' Purpose:  Delete All Printers
'***********************************************
Private Function DeleteAllPrinters

    sPrinterDriver_list = "Dell Photo P703w AIO Printer" 
                          
    sHID_list  = "Dell_Photo_P703w_AIO605A"
    
    ' Get the Arguments object
    Set ArgObj = WScript.Arguments

    Set WshShell = WScript.CreateObject("WScript.Shell")
    Set oEnv = WshShell.Environment("PROCESS")
    Set oFileSystem = WScript.CreateObject("Scripting.FileSystemObject")

    ' Get Arrays
    sPrinterDriver_array = Split(sPrinterDriver_list, "@")
    sHID_array = Split(sHID_list, " ")

    'Get installed printers and ports
    sComputer = "."
    On Error Resume Next
    Set oWMIService = GetObject("winmgmts:" _
            & "{impersonationLevel=impersonate}!\\" & sComputer & "\root\cimv2")

    Set colInstalledPrinters = oWMIService.ExecQuery _
             ("Select * from Win32_Printer", "WQL", _
             wbemFlagReturnImmediately + wbemFlagForwardOnly)
       
    For Each oItem In colInstalledPrinters 
        For Each sPrinter in sPrinterDriver_array
           If  (oItem.DriverName = sPrinter) Then
              sPrinterInstalled_list = sPrinterInstalled_list & oItem.Name & "@"
              sPrinterDriverInstalled_list =  sPrinterDriverInstalled_list & oItem.DriverName & "@"
           End If           
        Next        
    Next
    If Right(sPrinterInstalled_list,1)="@" Then
      sPrinterInstalled_list=Left(sPrinterInstalled_list,Len(sPrinterInstalled_list)-1)
    End If
    If Right(sPrinterDriverInstalled_list,1)="@" Then
      sPrinterDriverInstalled_list=Left(sPrinterDriverInstalled_list,Len(sPrinterDriverInstalled_list)-1)
    End If

    Set colInstalledPorts = oWMIService.ExecQuery _
             ("Select * from Win32_TCPIPPrinterPort", "WQL", _
             wbemFlagReturnImmediately + wbemFlagForwardOnly)
       
    For Each oItem In colInstalledPorts 
       sTCPIPPorts_list = sTCPIPPorts_list & oItem.Name & "@"   
    Next
    If Right(sTCPIPPorts_list,1)="@" Then
      sTCPIPPorts_list=Left(sTCPIPPorts_list,Len(sTCPIPPorts_list)-1)
    End If
    On Error Goto 0

    'Get arrays
    sPrinterInstalled_array = Split(sPrinterInstalled_list, "@")
    sPrinterDriverInstalled_array = Split(sPrinterDriverInstalled_list, "@")
    sTCPIPPorts_array = Split(sTCPIPPorts_list, "@")

    'Delete Forms if Forms have changed.
    'Remove possible registry entiries, spooler restart required.
    'Need to find a way to call Windows OpenPrinter, EnumForms, DeleteForm, ClosePrinter
    For Each sPrinter in sPrinterInstalled_array
        Call DeleteFormRegEntrys(sPrinter)
    Next

    'Delete installed Printers
    For Each sPrinter in sPrinterInstalled_array
        Call DeletePrinter(sPrinter)
    Next

    ' Vista - Remove Driver Store / Driver Package
    For Each sHID in sHID_array
        Call DeletePackageViaOEM_INF(sHID)
    Next
    
    'Delete all Driver of known printers
    For Each sPrinter in sPrinterDriver_array
        Call DeletePrinterDriver(sPrinter)
    Next

    ' Remove OEM INF files from Windows INF directory
    For Each sHID in sHID_array
        Call DeleteOEM_INF(sHID)
    Next

    'Remove our TCP/IP ports
    For Each sTCPIPPort in sTCPIPPorts_array
        Call DeleteTCPIPPort(sTCPIPPort)
    Next

    'Clean up all spurios entities
    'Shutdown
    Call ProcessTerminate("DLKAMDN.EXE")
    Call ProcessTerminate("DLKAPRE.EXE")
    Call ProcessTerminate("DLKAMUI.EXE")


    'Stop spooler, need to do this to make sure it shuts down
    WshShell.Run "Net Stop Spooler",0,true
    WshShell.Run "Net Start Spooler",0,true
    WshShell.Run "Net Stop Spooler",0,true

    'Delete installed files if any still exist
    Call DeleteFiles(sHID_array)

    'Remove possible registry entires.
    For Each sPrinter in sPrinterDriver_array
        Call DeletePrinterRegEntry(sPrinter)
    Next

    Call DeletePPRRegEntry("Dell Photo AIO Print Processor")

    Call DeleteLMRegEntry("Dell Photo AIO Language Monitor")
    
    ' Start Spooler
    WshShell.Run "Net Start Spooler",0,true

End Function

'***********************************************
' Function: DeletePrinterRegEntry
' Purpose:  Delete Printer Registery Entry
' Input:      Name of Driver
'***********************************************
Private Function DeletePrinterRegEntry( sDriverName )
    On Error Resume Next
    
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Printers\" & sDriverName  & "\DsDriver\"
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Printers\" & sDriverName  & "\DsSpooler\"
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Printers\" & sDriverName  & "\PnPData\"
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Printers\" & sDriverName  & "\PrinterDriverData\"
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Printers\" & sDriverName  & "\"

    For index = 0 To 9 
        WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Printers\" & sDriverName  & "," & index & "\DsDriver\"
        WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Printers\" & sDriverName  & "," & index & "\DsSpooler\"
        WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Printers\" & sDriverName  & "," & index & "\PnPData\"
        WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Printers\" & sDriverName  & "," & index & "\PrinterDriverData\"
        WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Printers\" & sDriverName  & "," & index & "\"
    Next
    
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Environments\Windows NT x86\Drivers\Version-3\" & sDriverName & "\"
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Environments\Windows x64\Drivers\Version-3\" & sDriverName & "\"
    WshShell.RegDelete "HKCU\Printers\DevModePerUser\" & sDriverName 
    WshShell.RegDelete "HKCU\Printers\DevModes2\" & sDriverName
    
    On Error Goto 0
End Function

'***********************************************
' Function: DeletePPRRegEntry
' Purpose:  Delete Printer Processor Registery Entry
' Input:      Name of Driver
'***********************************************
Private Function DeletePPRRegEntry ( strPPRName )
    On Error Resume Next
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Environments\Windows NT x86\Print Processors\" &  strPPRName & "\"
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Environments\Windows x64\Print Processors\" &  strPPRName & "\"
    On Error Goto 0
End Function

'***********************************************
' Function: DeleteLMRegEntry
' Purpose:  Delete Printer Processor Registery Entry
' Input:      Name of Driver
'***********************************************
Private Function DeleteLMRegEntry ( strLMName )
    On Error Resume Next
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Monitors\" & strLMName & "\"
    WshShell.RegDelete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Run\DLKAStatusMonitor"
    On Error Goto 0
End Function

'***********************************************
' Function: TerminateProcess
' Purpose:  Terminates a process
' Input:      Name of process
'***********************************************
Private Function ProcessTerminate( sProcess )
    Dim colProcessList, oProcess

    On Error Resume Next   
    Set colProcessList = GetObject("Winmgmts:").ExecQuery _
        ("Select * from Win32_Process Where Name ='" & sProcess & "'")
    For Each oProcess in colProcessList
        oProcess.Terminate( )
    Next

    Set colProcessList = Nothing
    On Error Goto 0  
  
End Function

'***********************************************
' Function: DeletePackageViaOEM_INF
' Purpose:  Delete Package OEM#.INF
' Input:    String to find in OEM#.inf
'***********************************************
Private Function DeletePackageViaOEM_INF( sDeleteOn )

    Dim i
    Dim oFile
    Dim sText
    Dim sFile
    Dim sFilePNF
    Dim sOS
    Dim sExecCommand

    sOS = GetOS
    
    If sOS = "Windows Vista" or sOS = "Windows 7" Then
        For i = 0 to 999 Step 1
            sFile = oEnv("SYSTEMROOT") & "\INF\OEM" & i & ".INF"
            sFilePNF = oEnv("SYSTEMROOT") & "\INF\OEM" & i & ".PNF"
            If oFileSystem.FileExists(sFile) then 	
                On Error Resume Next
                Set oFile = oFileSystem.OpenTextFile(sFile, 1)
                sText = oFile.ReadAll
                oFile.Close
                If InStr(1, sText, sDeleteOn, 1) <> 0 Then
                    sExecCommand= "pnputil.exe -f -d OEM" & i & ".INF"                            
                    WshShell.Run sExecCommand,0,true	
                End if
                On Error Goto 0
            End if
        Next
    End If

End Function


'***********************************************
' Function: DeleteOEM_INF
' Purpose:  Delete OEM#.INF
' Input:    String to find in OEM#.inf
'***********************************************
Private Function DeleteOEM_INF( sDeleteOn )
    Dim i
    Dim oFile
    Dim sText
    Dim sFile
    Dim sFilePNF
    For i = 0 to 999 Step 1
        sFile = oEnv("SYSTEMROOT") & "\INF\OEM" & i & ".INF"
        sFilePNF = oEnv("SYSTEMROOT") & "\INF\OEM" & i & ".PNF"
        If oFileSystem.FileExists(sFile) then 	
            On Error Resume Next
            Set oFile = oFileSystem.OpenTextFile(sFile, 1)
            sText = oFile.ReadAll
            oFile.Close
            On Error Goto 0
            If InStr(1, sText, sDeleteOn, 1) <> 0 Then
                oFileSystem.DeleteFile sFile, true
                oFileSystem.DeleteFile sFilePNF, true
            End if
        End if
    Next
End Function

'***********************************************
' Function: DeleteOEM_INF
' Purpose:  Delete OEM#.INF
' Input:    String to find in OEM#.inf
'***********************************************
Private Function DeleteOEM_INF( sDeleteOn )
    Dim i
    Dim oFile
    Dim sText
    Dim sFile
    Dim sFilePNF
    For i = 0 to 999 Step 1
        sFile = oEnv("SYSTEMROOT") & "\INF\OEM" & i & ".INF"
        sFilePNF = oEnv("SYSTEMROOT") & "\INF\OEM" & i & ".PNF"
        If oFileSystem.FileExists(sFile) then 	
            On Error Resume Next
            Set oFile = oFileSystem.OpenTextFile(sFile, 1)
            sText = oFile.ReadAll
            oFile.Close
            On Error Goto 0
            If InStr(1, sText, sDeleteOn, 1) <> 0 Then
                On Error Resume Next
                oFileSystem.DeleteFile sFile, true
                oFileSystem.DeleteFile sFilePNF, true
                On Error Goto 0
            End if
        End if
    Next
End Function

'***********************************************
' Function: DeleteTCPIPPort
' Purpose:  Delete Standard TCP/IP Port
' Input:    String to find in port name
'***********************************************
Private Function DeleteTCPIPPort( sDeleteOn )
    Dim sExecCommand, sPath
    Dim Controller, RemoteScript

    sPath = GetPrintVBSPath
  
    If (InStr(1, sDeleteOn, "KodakESP", 1) <> 0) Then
        On Error Resume Next
        sExecCommand = "cscript " & sPath & "\prnport.vbs -d -r """ & sDeleteOn & """"
        WshShell.Run sExecCommand,0,true
    On Error Goto 0

    End If
    
End Function

'***********************************************
' Function: DeleteFiles
' Purpose:  Deletes driver files
' Input:      None
'***********************************************
Private Function DeleteFiles ( sHID_array )
   Dim Prefixes_list
   Dim Directories_list
   Dim Files_list

   Dim prefixes_array
   Dim prefix
   Dim directories_array
   Dim directory
   Dim files_array
   Dim file
   Dim path

   Prefixes_list    = "dlka dl703"
                      
   Directories_list = "w32x86 x64"
   Files_list       = ".gpd .bud .ini .hlp .gid .chm "            & _
                      "MUI.exe MUI.dll PRE.exe PRE.dll RES.dll "  & _
                      "RRS.dll SDK.dll UIP.dll"

   prefixes_array    = Split(Prefixes_list, " ")
   directories_array = Split(Directories_list, " ")
   files_array       = Split(Files_list, " ")

   For Each prefix in prefixes_array
       For Each directory in directories_array
           For Each file in files_array
               path = oEnv("SYSTEMROOT") & "\system32\spool\drivers\" & directory & "\3\" & prefix & file

               On Error Resume Next
               oFileSystem.DeleteFile(path), true
               On Error Goto 0
           Next

           path = oEnv("SYSTEMROOT") & "\system32\spool\prtprocs\" & directory & "\" & prefix & "PPR.dll"

           On Error Resume Next
           oFileSystem.DeleteFile(path), true
           On Error Goto 0
     Next

     path = oEnv("SYSTEMROOT") & "\system32\" & prefix & "MON.dll"

     On Error Resume Next
     oFileSystem.DeleteFile(path), true
     On Error Goto 0

     path = oEnv("SYSTEMDRIVE") & "\Documents and Settings\All Users\Application Data\Dell\Dell Photo AIO Printer\DLKA_Job.ini"

     On Error Resume Next
     oFileSystem.DeleteFile(path), true
     On Error Goto 0

     'path = oEnv("SYSTEMDRIVE") & "\Documents and Settings\All Users\Application Data\Dell\Dell Photo AIO Printer\DLKA_DriverUsage.xml"

     'On Error Resume Next
     'oFileSystem.DeleteFile(path), true
     'On Error Goto 0

   Next

    On Error Resume Next
    'XP 32-bit
    For Each sHID in sHID_array
        oFileSystem.DeleteFolder(oEnv("SYSTEMROOT") & "\system32\spool\drivers\w32x86\" & sHID) 
    Next
    
    'XP 64-bit
    For Each sHID in sHID_array
        oFileSystem.DeleteFolder(oEnv("SYSTEMROOT") & "\system32\spool\drivers\w64\" & sHID) 
    Next

End Function


'***********************************************
' Function: DeletePrinter
' Purpose:  Run Print VBS scripts to delete printer
' Input:    Printer Name  
'***********************************************
Private Function DeletePrinter( sDeleteOn  )
   
    Dim sExecCommand, sPath
    Dim Controller, RemoteScript

    sPath = GetPrintVBSPath
  
    On Error Resume Next
    sExecCommand = "cscript " & sPath & "\prnmngr.vbs -d -p """ & sDeleteOn & """"
    WshShell.Run sExecCommand,0,true
    On Error Goto 0

End  Function
 
'***********************************************
' Function: DeletePrinterDriver
' Purpose:  Run Print VBS scripts to delete driver 
' Input:    Driver Name  
'***********************************************
Private Function DeletePrinterDriver( sDeleteOn  )
   
    Dim sExecCommand, sPath
    Dim Controller, RemoteScript

    sPath = GetPrintVBSPath
  
    On Error Resume Next
    sExecCommand = "cscript " & sPath & "\prndrvr.vbs -d -m """ & sDeleteOn & """ -v 3 -e ""Windows NT x86"""
    WshShell.Run sExecCommand,0,true
    
    sExecCommand = "cscript " & sPath & "\prndrvr.vbs -d -m """ & sDeleteOn & """ -v 3 -e ""Windows x64"""
    WshShell.Run sExecCommand,0,true
    On Error Goto 0

End  Function

'***********************************************
' Function: DeleteFormRegEntry
' Purpose:  Delete Printer Forms Registery Entry
'           NOTE: DeletForm SDK SPI Should be used
'                 Not accessible from VBScript.
' Input:      Name of Driver
'***********************************************
Private Function DeleteFormRegEntrys ( sPrinter )

   Const wbemFlagReturnImmediately = &h10
   Const wbemFlagForwardOnly = &h20

   Dim Form_list
   Dim form_array
   Dim form
   Dim regKey
   Dim regEntry
   Dim sComputer

   On Error Resume Next
   scomputer = "."
   Set oWMIService = GetObject("winmgmts:" _
            & "{impersonationLevel=impersonate}!\\" & sComputer & "\root\cimv2")

   Set colInstalledPrinters = oWMIService.ExecQuery _
            ("Select * from Win32_Printer", "WQL", _
            wbemFlagReturnImmediately + wbemFlagForwardOnly)
   
   For Each oItem In colInstalledPrinters 
      If  (oItem.Name = sPrinter) Then
          Form_list = Join(oItem.PrinterPaperNames, "@")
      End If
   Next
   If Right(Form_list,1)="@" Then
      Form_list=Left(Form_list,Len(Form_list)-1)
   End If

   On Error Goto 0
 
   regKey =  "HKLM\SYSTEM\CurrentControlSet\Control\Print\Forms\"
   form_array = Split(Form_list, "@")
 
   On Error Resume Next
   For Each form in form_array
      If (form <> "B5") Then
          WshShell.RegDelete regKey & form
      End If
   Next
   On Error Goto 0
    
 End Function
 
'***********************************************
' Function: GetOS
' Purpose:  Get OS sing
'***********************************************
Private Function GetOS
    
    Dim oWMI, oItem, colItems
    Dim sComputer, VerOS, VerBig, Ver9x, Version9x, OS

    ' Here is where we interrogate the Operating System
    ' On Error Resume Next

    ' Get the computer name dot = this computer.
    sComputer = "."
    ' This is where WMI interrogates the operating system
    Set oWMI = GetObject("winmgmts:\\" & sComputer & "\root\cimv2")

    Set colItems = oWMI.ExecQuery("Select * from Win32_OperatingSystem",,48)

    ' Here we filter Version from the dozens of properties
    For Each oItem in colItems
        VerBig = Left(oItem.Version,3)
    Next

    ' Spot VerBig variable in previous section
    ' Note the output variable is called OSystem

    Select Case VerBig
        Case "6.1" GetOS = "Windows 7"
        Case "6.0" GetOS = "Windows Vista"
        Case "5.2" GetOS = "Windows 2003"
        Case "5.1" GetOS = "Windows XP"
        Case "5.0" GetOS = "Windows 2000"
        Case "4.0" GetOS = "Windows NT"
        Case Else GetOS = "Unknown"
    End Select

End Function

'***********************************************
' Function: GetPrintVBSPath
' Purpose:  Get path for Printer managment scripts
'***********************************************
Private Function GetPrintVBSPath

    Dim oWMI, oItem, colItems
    Dim sComputer, VerOS, VerBig, Ver9x, Version9x, OS

    ' Here is where we interrogate the Operating System
    ' On Error Resume Next

    ' Get the computer name dot = this computer.
    sComputer = "."
    ' This is where WMI interrogates the operating system
    Set oWMI = GetObject("winmgmts:\\" & sComputer & "\root\cimv2")

    Set colItems = oWMI.ExecQuery("Select * from Win32_OperatingSystem",,48)

    ' Here we filter Version from the dozens of properties
    For Each oItem in colItems
        VerBig = Left(oItem.Version,3)
    Next

    ' Spot VerBig variable in previous section
    ' Note the output variable is called OSystem

    Select Case VerBig
        Case "6.1" GetPrintVBSPath = oEnv("SYSTEMROOT") & "\System32\Printing_Admin_Scripts\en-US"
        Case "6.0" GetPrintVBSPath = oEnv("SYSTEMROOT") & "\System32\Printing_Admin_Scripts\en-US"
        Case "5.2" GetPrintVBSPath = oEnv("SYSTEMROOT") & "\System32" 
        Case "5.1" GetPrintVBSPath = oEnv("SYSTEMROOT") & "\System32" 
        Case "5.0" GetPrintVBSPath = oEnv("SYSTEMROOT") & "\System32" 
        Case Else GetPrintVBSPath = oEnv("SYSTEMROOT") & "\System32\Printing_Admin_Scripts\en-US"
    End Select
   
End Function